---
- name: playbook installation de python, flask et docker
  hosts: flask
  become: yes
  tasks:
    - name: Mise à jour des paquets apt
      apt:
        update_cache: yes

    - name: Installation de Python
      apt:
        name: python3
        state: present

    - name: Installation de pip (gestionnaire de paquets Python)
      apt:
        name: python3-pip
        state: present

    - name: Mise à jour de pip
      pip:
        name: pip
        state: latest

    - name: Installation de Flask via pip
      pip:
        name: flask
        state: present
        extra_args: --ignore-installed

    - name: Installation de Docker
      apt:
        name: docker.io
        state: present

    - name: Installation du module Docker pour Python
      pip:
        name: docker
        state: present

    - name: Démarrage du service Docker
      systemd:
        name: docker
        state: started
        enabled: yes

    - name: Ajout de l'utilisateur vagrant au groupe docker
      user:
        name: vagrant
        groups: docker
        append: yes


	- name: Créer un répertoire flask
      file:
        path: /home/flask
        state: directory

    - name: Créer le fichier app.py
      ansible.builtin.file:
        path: /home/flask/app.py
        state: touch

    - name: Créer le script le site Flask
      blockinfile:
        path: /home/flask/app.py
        block: |
          from flask import Flask, render_template

          app = Flask(__name__, template_folder='template')

          @app.route('/')
          def index():
              return render_template('index.html')

          @app.route('/about')
          def about():
              return render_template('about.html')

          @app.route('/contact')
          def contact():
              return render_template('contact.html')

          if __name__ == '__main__':
              app.run(host='0.0.0.0', port=5000, debug=True)

	- name: Créer un répertoire template
      file:
        path: /home/flask/template
        state: directory

    - name: Créer la page d'accueil
      ansible.builtin.file:
        path: /home/flask/template/index.html
        state: touch

    - name: Créer la page de contact
      ansible.builtin.file:
        path: /home/flask/template/contact.html
        state: touch

    - name: Créer la page a propos
      ansible.builtin.file:
        path: /home/flask/template/about.html
        state: touch

    - name: Ma page index
      blockinfile:
        path: /home/flask/template/index.html
        block: |
          <!DOCTYPE html>
		  <html lang="fr">
		  <head>
			  <meta charset="UTF-8">
			  <meta name="viewport" content="width=device-width, initial-scale=1.0">
			  <title>Mon Site Web</title>
		  </head>
		  <body>
			  <nav>
				  <ul>
					  <li><a href="index.html">Accueil</a></li>
					  <li><a href="about.html">À Propos</a></li>
					  <li><a href="contact.html">Contact</a></li>
				  </ul>
			  </nav>
			  <main>
				  <!-- Page d'accueil -->
				  <section id="accueil">
					  <h1>Bienvenue sur mon site web, Adrien DESDOITS</h1>
				  </section>
			  </main>
		  </body>
		  </html>


    - name: Ma page a propos
      blockinfile:
        path: /home/flask/template/about.html
        block: |
			<!DOCTYPE html>
			<html lang="fr">
			<head>
				<meta charset="UTF-8">
				<meta name="viewport" content="width=device-width, initial-scale=1.0">
				<title>À Propos</title>
			</head>
			<body>
				<nav>
					<ul>
						<li><a href="index.html">Accueil</a></li>
						<li><a href="about.html">À Propos</a></li>
						<li><a href="contact.html">Contact</a></li>
					</ul>
				</nav>
				<main>
					<!-- Page À Propos -->
					<section id="about">
						<h1>À propos de moi</h1>
						<p>Je suis en master 2 à Ensitech.</p>
					</section>
				</main>
			</body>
			</html>


    - name: Ma page contact
      blockinfile:
        path: /home/flask/template/contact.html
        block: |
			<!DOCTYPE html>
			<html lang="fr">
			<head>
				<meta charset="UTF-8">
				<meta name="viewport" content="width=device-width, initial-scale=1.0">
				<title>Contact</title>
			</head>
			<body>
				<nav>
					<ul>
						<li><a href="index.html">Accueil</a></li>
						<li><a href="about.html">À Propos</a></li>
						<li><a href="contact.html">Contact</a></li>
					</ul>
				</nav>
				<main>
					<!-- Page Contact -->
					<section id="contact">
						<h1>Pour me contacter</h1>
						<p>Voici le formulaire :</p>
						<form action="#" method="post">
							<label for="nom">Nom :</label>
							<input type="text" id="nom" name="nom" required><br><br>
							<label for="prenom">Prénom :</label>
							<input type="text" id="prenom" name="prenom" required><br><br>
							<label for="sujet">Sujet :</label>
							<input type="text" id="sujet" name="sujet" required><br><br>
							<input type="submit" value="Envoyer">
						</form>
					</section>
				</main>
			</body>
			</html>


